"use strict";
const allExtensions = ['.ts', '.tsx', '.d.ts', '.js', '.jsx'];
const config = {
    parserOptions: {
        ecmaVersion: 2018,
        sourceType: 'module'
    },
    settings: {
        'import/extensions': allExtensions,
        'import/ignore': ['node_modules', '\\.(coffee|scss|css|less|hbs|svg|json)$'],
        'import/external-module-folders': ['node_modules', 'node_modules/@types'],
        'import/parsers': {
            '@typescript-eslint/parser': ['.ts', '.tsx', '.d.ts']
        },
        'import/resolver': {
            node: {
                extensions: allExtensions
            }
        }
    },
    rules: {
        'import/no-unresolved': [
            'error',
            {
                caseSensitive: true
            }
        ],
        'import/named': 'off',
        'import/no-commonjs': 'warn',
        'import/no-nodejs-modules': 'error',
        'import/extensions': [
            'error',
            'ignorePackages',
            {
                ts: 'never',
                tsx: 'never',
                js: 'never',
                jsx: 'never'
            }
        ],
        'import/order': [
            'error',
            {
                groups: [['builtin', 'external', 'internal'], 'parent', ['sibling', 'index'], ['object', 'unknown']],
                'newlines-between': 'always'
            }
        ],
        'import/exports-last': 'error',
        'import/no-unused-modules': 'off'
    }
};
module.exports = config;
